#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <sys/types.h>
#include <netdb.h>
#include <netinet/in.h>
#include <arpa/inet.h>

int check_serial(char *serial) {
    int flag = 0;
    char serial_buff[256];
    strcpy(serial_buff, serial);
    if (strcmp(serial_buff, "SN123456") == 0) flag = 1;
	
    return flag;
}

int main(int argc, char *argv[]) {
    // 変数宣言
    struct sockaddr_in serv_addr, clnt_addr;
    int serv_socket, clnt_socket;
    socklen_t addr_len;
    int port_num = 5001;
    char *buff = malloc(512);
    
    // ソケットの初期化
    serv_socket = socket(AF_INET, SOCK_STREAM, 0);
    serv_addr.sin_family = AF_INET;
    serv_addr.sin_addr.s_addr = INADDR_ANY;
    serv_addr.sin_port = htons(port_num);

    // ソケットのバインドとクライアント受付開始
    bind(serv_socket, (struct sockaddr *)&serv_addr, sizeof(serv_addr));
    listen(serv_socket, 1);
    
    while (1) {
        // 接続を許可
        fprintf(stderr, "Waiting for a client...\n");
        addr_len = sizeof(clnt_addr);
        clnt_socket = accept(serv_socket, (struct sockaddr *) &clnt_addr, &addr_len);
        fprintf(stderr, "Accepted a connection from [%s, %d]\n", inet_ntoa(clnt_addr.sin_addr), clnt_addr.sin_port);
    	
        // シリアル番号の受信
        buff[0] = '\0';
        read(clnt_socket, buff, 512);

        // シリアル番号のチェックと結果の送信
        if (check_serial(buff)) {
            strcpy(buff, "Serial number is correct.\n");
        } else {
            strcpy(buff, "Serial number is wrong.\n");
        }
        write(clnt_socket, buff, 512);
        buff[0] = '\0';

        // ソケットを閉じる
        close(clnt_socket);
    }

    // ソケットを閉じる
    close(serv_socket);
    
    return 0;
}
